---
title: XRInputSource
slug: Web/API/XRInputSource
tags:
  - API
  - AR
  - Augmented Reality
  - Experimental
  - Input
  - Interface
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XRInputSource
  - control
---
<div>{{securecontext_header}}{{APIRef("WebXR Device API")}}</div>

<p><span class="seoSummary">The <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API's</a> <strong><code>XRInputSource</code></strong> interface describes a single source of control input which is part of the user's WebXR-compatible virtual or augmented reality system.</span> The device is specific to the platform being used, but provides the direction in which it is being aimed and optionally may generate events if the user triggers performs actions using the device.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("XRInputSource.gamepad", "gamepad")}} {{ReadOnlyInline}}{{experimental_inline}}</dt>
 <dd>
 <p>A {{domxref("Gamepad")}} object describing the state of the buttons and axes on the XR input source, if it is a gamepad or comparable device. If the device isn't a gamepad-like device, this property's value is <code>NULL</code>.</p>

 <div class="note"><strong>Note:</strong> While <code>XRInputSource</code> uses the {{domxref("Gamepad")}} interface from the <a href="/en-US/docs/Web/API/Gamepad_API">Gamepad API</a>, this input device is strictly associated with the WebXR hardware and is not a general-purpose gaming device.</div>
 </dd>
 <dt>{{domxref('XRInputSource.gripSpace', 'gripSpace')}}{{readonlyInline}}</dt>
 <dd>An {{domxref("XRSpace")}} whose origin tracks the pose which is used to render objects which should appear as if they're held in the hand indicated by <code>handedness</code>. The orientation of this space indicates the angle at which the hand is gripping the object. Read on in the main article on {{domxref("XRInputSource.gripSpace", "gripSpace")}} for more details on how to use this space.</dd>
 <dt>{{domxref('XRInputSource.handedness', 'handedness')}}{{readonlyInline}}</dt>
 <dd>A {{domxref("DOMString")}} that indicates which hand the device represented by this <code>XRInputSource</code> is being used in, if any. The value will be <code>left</code>, <code>right</code>, or <code>none</code>.</dd>
 <dt>{{domxref('XRInputSource.profiles', 'profiles')}}{{readonlyInline}}</dt>
 <dd>An array of <code>DOMString</code> objects, each specifying the name of an input profile describing the preferred visual representation and behavior of this input source.</dd>
 <dt>{{domxref('XRInputSource.targetRayMode', 'targetRayMode')}}{{readonlyInline}}</dt>
 <dd>
 <p>A <code>DOMString</code> indicating the methodology used to produce the target ray: <code>gaze</code>, <code>tracked-pointer</code>, or <code>screen</code>.</p>
 </dd>
 <dt>{{domxref('XRInputSource.targetRaySpace', 'targetRaySpace')}}{{readonlyInline}}</dt>
 <dd>An {{domxref("XRSpace")}} object defining the origin of the target ray and the direciton in which it extends. This space is established using the method defined by <code>targetRayMode</code>.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>The <code>XRInputSource</code> interface defines no methods.</em></p>

<h2 id="Usage_notes">Usage notes</h2>

<h3 id="Actions_and_the_target_ray">Actions and the target ray</h3>

<p>If the device provides an indication of the direction in which it is pointed, this is done using a <strong>target ray</strong>. This is a ray extending from the position of the device outward in the direction in which it is pointed.</p>

<div style="width: 42em;">
<figure style="background: #eee; padding: 0.5em; border: 1px solid #aaa; border-radius: 1em; max-width: 504px; padding: 1em; margin: 1em auto;">
<figcaption><strong>A target ray emitted by a hand controller.</strong></figcaption>
<img alt="A screenshot showing a target ray being emitted by a hand controller" src="https://mdn.mozillademos.org/files/17089/example-target-ray.gif" style="width: 100%;"></figure>
</div>

<p class="cleared">If the device includes a trigger or other squeezable input, such as a hand gesture device that recognizes when the user squeezes their fist, that action is called a <strong>primary squeeze action</strong>. A primary squeeze action should correspond to a gripping act in reality, such as taking hold of an object or pressing a trigger on a tool or weapon. When a squeeze action begins, such as by the user pressing the trigger or tightening their grip, a {{domxref("XRSession.squeezestart_event", "squeezestart")}} event is sent to the <code>XRSession</code>. Once the action is completed and the user has released the trigger or the grip, a {{domxref("XRSession.squeeze_event", "squeeze")}} event is sent. This is followed by a {{domxref("XRSession.squeezeend_event", "squeezeend")}}, which is also sent if the action is aborted rather than completed.</p>

<p>If the device has a button or other pressable input control, it is a <strong>primary input source</strong>, and this button is a <strong>primary action</strong>. A primary action may occur when the user presses a button, clicks on a touchpad or the top button of a thumb stick, or uses a hand gesture or spoken command that invokes the button-like action. When a primary action begins, a {{domxref("XRSession.selectstart_event", "selectstart")}} event is sent to the {{domxref("XRSession")}}. When the action has completed (such as when the user releases the button), a {{domxref("XRSession.select_event", "select")}} event is sent. Finally, once that is done—or if the user aborts the action—a {{domxref("XRSession.selectend_event", "selectend")}} event is sent to the session object.</p>

<p>An action may be aborted either by the user in some device-specific fashion or if the input device is disconnected before the action is completed.</p>

<h3 id="Local_coordinate_system">Local coordinate system</h3>

<p>Each input source has its own local coordinate system, which is described by the {{domxref("XRInputSource.gripSpace", "gripSpace")}} property, which is an {{domxref("XRSpace")}} used to map the input's coordinate system into the world coordinate system. The grip space's coordinate system can then be used to render objects so they appear to be held in the user's hand.</p>

<p><img alt="A diagram showing the coordinate system defined by the gripSpace property" src="https://mdn.mozillademos.org/files/17215/xr-hand-axes.svg" style="height: 472px; width: 450px;"></p>

<p>For more details on the input source's coordinate system, see the article that covers the {{domxref("XRInputSource.gripSpace", "gripSpace")}} property in detail.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#xrinputsource-interface','XRInputSource')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRInputSource")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">Inputs and input sources</a></li>
 <li><a href="/en-US/docs/Web/WebXR%20Device%20API/Gamepads">Using gamepads in WebXR applications</a></li>
 <li>{{domxref("XRInputSourceArray")}}</li>
 <li>{{domxref("XRSpace")}}</li>
</ul>
